--
-- K744R4
-- Specialization for K744R4
--
-- @author  	Aluha74rus
-- @version 	v1.0
-- @date  		02/09/19
--

K744R4 = {};

local K744R4_directory = g_currentModDirectory;

function K744R4.prerequisitesPresent(specializations)
    return true;
end;

function K744R4.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", K744R4);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", K744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", K744R4)
end

function K744R4.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "playklawishaAnims", K744R4.playklawishaAnims)
    SpecializationUtil.registerFunction(vehicleType, "getTrailer", K744R4.getTrailer)
    SpecializationUtil.registerFunction(vehicleType, "getLoverTurnON", K744R4.getLoverTurnON)
end

function K744R4:onLoad(savegame)
		
    self.breakLights = {}
    self.breakLights.lightShaderNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.lights.breakLights.light#shaderNode"))
    self.breakLights.intensity = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.lights.breakLights.light#intensity")) or 1000
    self.breakLights.lightNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.lights.breakLights.light#node"))
    self.breakLights.realLightNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.lights.breakLights.realLight#node"))
    if self.breakLights.realLightNode ~= nil then
        light.defaultColor = {getLightColor(self.breakLights.realLightNode)}
        setVisibility(realLightNode, false)
    end
    if self.breakLights.lightNode ~= nil then
        setVisibility(self.breakLights.lightNode, false)
    end
	self.breakLightsAktive = false
    self.breakLightsTimer = 0;	
	
    self.startLowerControlMaxTimeout = 2000
    self.startLowerControlMaxTime = 0
    self.startLowerControlMinTimeout = 2000
    self.startLowerControlMinTime = 0
    self.leverMax = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.leverMax#node"));
    self.leverMin = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.leverMin#node"));
	
	self.breakLightsVis = I3DUtil.indexToObject(self.components, "1>7|4|0|7");	
	self.podMonitor = I3DUtil.indexToObject(self.components, "0>1|12|1");	
	self.pust = I3DUtil.indexToObject(self.components, "0>1|3|4");	
	self.pust1 = I3DUtil.indexToObject(self.components, "0>1|3|8|0|1");	
	self.pust2 = I3DUtil.indexToObject(self.components, "0>3|27|0|9");	
	self.pust3 = I3DUtil.indexToObject(self.components, "0>3|27|0|10");		
	self.pust4 = I3DUtil.indexToObject(self.components, "0>1|1|2|12");	
	
	self.oneSD = I3DUtil.indexToObject(self.components, "0>3|27|0|0");	
	self.twoSD = I3DUtil.indexToObject(self.components, "0>3|27|0|1");	
	self.threeSD = I3DUtil.indexToObject(self.components, "0>3|27|0|2");	
	self.fourSD = I3DUtil.indexToObject(self.components, "0>3|27|0|3");	
	self.TD = I3DUtil.indexToObject(self.components, "0>3|27|0|7");
	self.ND = I3DUtil.indexToObject(self.components, "0>3|27|0|10|0");	
	self.HD = I3DUtil.indexToObject(self.components, "0>3|27|0|5");
	self.LD = I3DUtil.indexToObject(self.components, "0>3|27|0|6");
	
	self.oneS = I3DUtil.indexToObject(self.components, "0>1|3|0");	
	self.twoS = I3DUtil.indexToObject(self.components, "0>1|3|1");	
	self.threeS = I3DUtil.indexToObject(self.components, "0>1|3|2");	
	self.fourS = I3DUtil.indexToObject(self.components, "0>1|3|3");	
	self.T = I3DUtil.indexToObject(self.components, "0>1|3|5");
	self.N = I3DUtil.indexToObject(self.components, "0>1|3|4|0");	
	self.H = I3DUtil.indexToObject(self.components, "0>1|3|8|1|0");
	self.L = I3DUtil.indexToObject(self.components, "0>1|3|8|1|1");
	self.F = I3DUtil.indexToObject(self.components, "0>1|3|8|0|0");
	self.R = I3DUtil.indexToObject(self.components, "0>1|3|8|0|2");
	self.FR = I3DUtil.indexToObject(self.components, "0>1|3|8|0|1|0");
	self.PodMassa = I3DUtil.indexToObject(self.components, "0>1|1|2|2|0");
	self.Komp = I3DUtil.indexToObject(self.components, "0>1|1|2|7");
    self.KlawishaMassa = getXMLString(self.xmlFile, "vehicle.KlawishaMassa#animationName");
    self.Monitor = getXMLString(self.xmlFile, "vehicle.Monitor#animationName");
    self.Monitor1 = getXMLString(self.xmlFile, "vehicle.MonitorDisp#animationName");
    self.Zagiganie = getXMLString(self.xmlFile, "vehicle.Zagiganie#animationName");
	self.gearShifter = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.gearShifter#index"));
	self.klawishaLH = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.klawishaLH#index"));
    self.KlawishaFR = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.Klawisha#KlawishaFR"));
	self.dd = {}
	self.dd.f = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.forward#index"));
	self.dd.fa = false;
	self.dd.b = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.backward#index"));
	self.dd.ba = false;
	setVisibility( self.dd.f, false );
	setVisibility( self.dd.b, false );	
	
    self.speedWaitingMaxTimeMonitor = 2500; 
	self.speedWaitingTimerMonitor = 1; 
	self.monitorFirst  = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.monitorImage#firstIndex"));
	self.monitorSecond = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.monitorImage#secondIndex"));
	self.monitorThird  = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.monitorImage#thirdIndex"));
	
    local blinkerhebelNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.Poworotniki#index"));
    if blinkerhebelNode ~= nil then
        self.blinkerhebel = {};
        self.blinkerhebel.node = blinkerhebelNode;
        local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile, "vehicle.K744R4.Poworotniki#minRot"));
        self.blinkerhebel.minRot = {};
        self.blinkerhebel.minRot[1] = MathUtil.degToRad(Utils.getNoNil(x, 0));
        self.blinkerhebel.minRot[2] = MathUtil.degToRad(Utils.getNoNil(y, 0));
        self.blinkerhebel.minRot[3] = MathUtil.degToRad(Utils.getNoNil(z, 0));

        local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile, "vehicle.K744R4.Poworotniki#rotLeft"));
        self.blinkerhebel.leftRot = {};
        self.blinkerhebel.leftRot[1] = MathUtil.degToRad(Utils.getNoNil(x, 0));
        self.blinkerhebel.leftRot[2] = MathUtil.degToRad(Utils.getNoNil(y, 0));
        self.blinkerhebel.leftRot[3] = MathUtil.degToRad(Utils.getNoNil(z, 0));

        local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile, "vehicle.K744R4.Poworotniki#rotRight"));
        self.blinkerhebel.rightRot = {};
        self.blinkerhebel.rightRot[1] = MathUtil.degToRad(Utils.getNoNil(x, 0));
        self.blinkerhebel.rightRot[2] = MathUtil.degToRad(Utils.getNoNil(y, 0));
        self.blinkerhebel.rightRot[3] = MathUtil.degToRad(Utils.getNoNil(z, 0));

        self.blinkerhebel.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.K744R4.Poworotniki#rotTime"), 1)*1000;
		self.blinkerhebel.lastDir = 1;
    end;
	
    local leverTrailerNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.K744R4.leverTrailer#node"));
    if leverTrailerNode ~= nil then
        self.leverTrailer = {};
        self.leverTrailer.node = leverTrailerNode;
        local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile, "vehicle.K744R4.leverTrailer#minRot"));
        self.leverTrailer.minRot = {};
        self.leverTrailer.minRot[1] = MathUtil.degToRad(Utils.getNoNil(x, 0));
        self.leverTrailer.minRot[2] = MathUtil.degToRad(Utils.getNoNil(y, 0));
        self.leverTrailer.minRot[3] = MathUtil.degToRad(Utils.getNoNil(z, 0));

        local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile, "vehicle.K744R4.leverTrailer#upRot"));
        self.leverTrailer.upRot = {};
        self.leverTrailer.upRot[1] = MathUtil.degToRad(Utils.getNoNil(x, 0));
        self.leverTrailer.upRot[2] = MathUtil.degToRad(Utils.getNoNil(y, 0));
        self.leverTrailer.upRot[3] = MathUtil.degToRad(Utils.getNoNil(z, 0));

        local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile, "vehicle.K744R4.leverTrailer#downRot"));
        self.leverTrailer.downRot = {};
        self.leverTrailer.downRot[1] = MathUtil.degToRad(Utils.getNoNil(x, 0));
        self.leverTrailer.downRot[2] = MathUtil.degToRad(Utils.getNoNil(y, 0));
        self.leverTrailer.downRot[3] = MathUtil.degToRad(Utils.getNoNil(z, 0));

        self.leverTrailer.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.K744R4.leverTrailer#rotTime"), 1)*1000;
		self.leverTrailer.lastDir = 1;
    end
	self.leverTrailerMaxAktive = false	
	self.leverTrailerMinAktive = false	
	
    
    local baseString = string.format("vehicle.K744R4.");
    self.klawishaAnims = {};
    if hasXMLProperty(self.xmlFile, "vehicle.K744R4.klawishaAnims") then
	
	
        self.klawishaAnims.leverTurnON = getXMLString(self.xmlFile,baseString.."klawishaAnims#leverTurnON");
        self.klawishaAnims.rucnik = getXMLString(self.xmlFile,baseString.."klawishaAnims#rucnik");
        self.klawishaAnims.rucnikTimer = 0;
        
        self.klawishaAnims.lights = {};
        i=0;
        while true do
            self.klawishaAnims.lights[i] = getXMLString(self.xmlFile,baseString..string.format("klawishaAnims.lights#animName%d", i));
            if self.klawishaAnims.lights[i] == nil then
                break;
            end;
            i=i+1;
        end;
        
        self.klawishaAnims.lightsAw = {};
        i=0;
        while true do
            self.klawishaAnims.lightsAw[i] = getXMLString(self.xmlFile,baseString..string.format("klawishaAnims.lightsAw#animName%d", i));
            if self.klawishaAnims.lightsAw[i] == nil then
                break;
            end;
            i=i+1;
        end;
    end;
    
end;
function K744R4:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
    if self.breakLightsAktive then
        local value = 1
        local _,y,z,w = getShaderParameter(self.breakLights.lightShaderNode, "lightControl")
        setShaderParameter(self.breakLights.lightShaderNode, "lightControl", math.max(value*self.breakLights.intensity, 1), y, z, w, false)
    elseif not self.breakLightsAktive then
        value = 0
        local _,y,z,w = getShaderParameter(self.breakLights.lightShaderNode, "lightControl")
        setShaderParameter(self.breakLights.lightShaderNode, "lightControl", math.max(value*self.breakLights.intensity, 0), y, z, w, false)
    end;   
    if self.isClient then
        for _, implement in pairs(self.spec_attacherJoints.attachedImplements) do
            local leverObject = implement.object
            if leverObject ~= nil then
                if not leverObject:getIsLowered(false) then
                    setRotation(self.leverMax, MathUtil.degToRad(15), 0, 0);
                    if self.startLowerControlMaxTime > g_currentMission.time then
                        setRotation(self.leverMax, 0, 0, 0);
                    end;
                else
                    self.startLowerControlMaxTime = g_currentMission.time + self.startLowerControlMaxTimeout
                end;
                if leverObject:getIsLowered(true) then
                    setRotation(self.leverMin, MathUtil.degToRad(-15), 0, 0);
                    if self.startLowerControlMinTime > g_currentMission.time then
                        setRotation(self.leverMin, 0, 0, 0);
                    end;
                else
                    self.startLowerControlMinTime = g_currentMission.time + self.startLowerControlMinTimeout
                end;
            end;
        end;
        
        if self.klawishaAnims.rucnik ~= nil then
            if (self.movingDirection == 0 or self:getLastSpeed()<0.2) or not self.spec_motorized.isMotorStarted then
                if self.klawishaAnims.rucnikTimer == 0 then
                    self.klawishaAnims.rucnikTimer = g_currentMission.time;
                end;
                if self.klawishaAnims.rucnikTimer + 2900 < g_currentMission.time then    
                    self:playklawishaAnims(self.klawishaAnims.rucnik, -1);
                    self.klawishaAnims.rucnikTimer = 0;
                end;
            else
                self.klawishaAnims.rucnikTimer = 0;
                self:playklawishaAnims(self.klawishaAnims.rucnik, 1);
            end;
        end;
        
        if self.breakLightsAktive ~= nil then
            if (self.movingDirection == 0 or self:getLastSpeed()<0.2) and self.spec_motorized.isMotorStarted then
                if self.breakLightsTimer == 0 then
                    self.breakLightsTimer = g_currentMission.time;
                end;
                if self.breakLightsTimer + 2900 < g_currentMission.time then    
                    self.breakLightsAktive = true
	                setVisibility(self.breakLightsVis, true);
                    self.breakLightsTimer = 0;
                end;
            else
                self.breakLightsTimer = 0;
	            setVisibility(self.breakLightsVis, false);
                self.breakLightsAktive = false
            end;
        end;
        if self.klawishaAnims.lights ~= nil then
            for i=0, self.spec_lights.numLightTypes do 
                if bitAND(self.spec_lights.lightsTypesMask, 2^i) ~= 0 then
                    self:playklawishaAnims(self.klawishaAnims.lights[i], 1);
                else
                    self:playklawishaAnims(self.klawishaAnims.lights[i], -1);
                end;
            end;
        end;
        if self.klawishaAnims.lightsAw ~= nil then
            for i=0, self.spec_lights.numLightTypes do 
                if self.spec_lights.turnLightState == 3 then
                    self:playklawishaAnims(self.klawishaAnims.lightsAw[i], 1);
                else
                    self:playklawishaAnims(self.klawishaAnims.lightsAw[i], -1);
                end;
            end;
        end;
    end;		
	if self.movingDirection > 0 and self.lastSpeed*3600 > 3 and self.dd.fa == false then
		self.dd.fa = true;
        setRotation(self.KlawishaFR, MathUtil.degToRad(7), 0, 0);
		setVisibility(self.dd.f, true);
	    setVisibility(self.F, true);
	elseif self.dd.fa == true and (self.lastSpeed*3600 < 3 or self.movingDirection < 0) then
		self.dd.fa = false;
	    setVisibility(self.F, false);
        setRotation(self.KlawishaFR, 0, 0, 0);
		setVisibility(self.dd.f, false);	
	end;
	if self.movingDirection < 0 and self.lastSpeed*3600 > 3 and self.dd.ba == false then
		self.dd.ba = true;
        setRotation(self.KlawishaFR, MathUtil.degToRad(-7), 0, 0);
		setVisibility(self.dd.b, true);
	    setVisibility(self.R, true);
	elseif self.dd.ba == true and (self.lastSpeed*3600 < 3 or self.movingDirection > 0) then
		self.dd.ba = false;
	    setVisibility(self.R, false);
        setRotation(self.KlawishaFR, 0, 0, 0);
		setVisibility(self.dd.b, false);	
	end;
	
    local MonitorEnableTimeStartDelay = 0;
	local MonitorEnableTime = (self.spec_motorized.motorStartTime - self.spec_motorized.motorStartDuration) + MonitorEnableTimeStartDelay;
	local Duration = 2840;
	local DisableTime = MonitorEnableTime + Duration;
	
    local Monitor1EnableTimeStartDelay = 2400;
	local Monitor1EnableTime = (self.spec_motorized.motorStartTime - self.spec_motorized.motorStartDuration) + Monitor1EnableTimeStartDelay;
	local Duration = 300;
	local DisableTime = Monitor1EnableTime + Duration;

    local ZagiganieEnableTimeStartDelay = 750;
	local ZagiganieEnableTime = (self.spec_motorized.motorStartTime - self.spec_motorized.motorStartDuration) + ZagiganieEnableTimeStartDelay;
	local Duration = 2040;
	local DisableTime = ZagiganieEnableTime + Duration;
	
    local KlawishaMassaEnableTimeStartDelay = 200;
	local KlawishaMassaEnableTime = (self.spec_motorized.motorStartTime - self.spec_motorized.motorStartDuration) + KlawishaMassaEnableTimeStartDelay;
	if self.isClient then
		if self.Monitor ~= nil and self.playAnimation ~= nil then
		    if (g_currentMission.time <= DisableTime and g_currentMission.time >= MonitorEnableTime  and self.spec_motorized.isMotorStarted) then
                self:playAnimation(self.Monitor, 1, nil, true);
		    else
                self:playAnimation(self.Monitor, -1, nil, true);
		    end;
		end;
		if self.Monitor1 ~= nil and self.playAnimation ~= nil then
		    if (g_currentMission.time <= DisableTime and g_currentMission.time >= Monitor1EnableTime  and self.spec_motorized.isMotorStarted) then
                self:playAnimation(self.Monitor1, 1, nil, true);
		    else
                self:playAnimation(self.Monitor1, -1, nil, true);
		    end;
		end;
		if self.Zagiganie ~= nil and self.playAnimation ~= nil then
		    if (g_currentMission.time <= DisableTime and g_currentMission.time >= ZagiganieEnableTime  and self.spec_motorized.isMotorStarted) then
                self:playAnimation(self.Zagiganie, 1, nil, true);
		    else
                self:playAnimation(self.Zagiganie, -1, nil, true);
		    end;
		end;
		if self.KlawishaMassa ~= nil and self.playAnimation ~= nil then
		    if (g_currentMission.time <= KlawishaMassaEnableTime  and self.spec_motorized.isMotorStarted) then
                self:playAnimation(self.KlawishaMassa, 1, nil, true);
		    else
                self:playAnimation(self.KlawishaMassa, -1, nil, true);
		    end;
		end;	
	end;
    if self.spec_motorized.isMotorStarted then
	    setVisibility(self.PodMassa, true);
	    setVisibility(self.Komp, true);
	    setVisibility(self.pust, true);
	    setVisibility(self.pust1, true);
	    setVisibility(self.pust2, true);
	    setVisibility(self.pust3, true);
	    setVisibility(self.pust4, true);
	    setVisibility(self.podMonitor, true);
	else
	    setVisibility(self.PodMassa, false);
	    setVisibility(self.Komp, false);
	    setVisibility(self.pust, false);
	    setVisibility(self.pust1, false);
	    setVisibility(self.pust2, false);
	    setVisibility(self.pust3, false);
	    setVisibility(self.pust4, false);
	    setVisibility(self.podMonitor, false);
	end;
		
	if self.spec_motorized.isMotorStarted then
	
        local speed = self.lastSpeed*3600;
        if self.gearShifter ~= nil  then    
            if speed < 0.1 then
                setRotation(self.gearShifter, MathUtil.degToRad(0),   MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.N, true);
	            setVisibility(self.FR, true);
	            setVisibility(self.T, false);
	            setVisibility(self.oneS, false);
	            setVisibility(self.twoS, false);
	            setVisibility(self.threeS, false);
	            setVisibility(self.fourS, false);
				
	            setVisibility(self.ND, true);
	            setVisibility(self.TD, false);
	            setVisibility(self.oneSD, false);
	            setVisibility(self.twoSD, false);
	            setVisibility(self.threeSD, false);
	            setVisibility(self.fourSD, false);
            else
			if speed >= 0.1 and speed < 0.3 then
                setRotation(self.gearShifter, MathUtil.degToRad(-20), MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.N, false);
	            setVisibility(self.FR, false);
	            setVisibility(self.T, true);
	            setVisibility(self.oneS, false);
	            setVisibility(self.twoS, false);
	            setVisibility(self.threeS, false);
	            setVisibility(self.fourS, false);
				
	            setVisibility(self.ND, false);
	            setVisibility(self.TD, true);
	            setVisibility(self.oneSD, false);
	            setVisibility(self.twoSD, false);
	            setVisibility(self.threeSD, false);
	            setVisibility(self.fourSD, false);
            elseif speed >= 0.3 and speed < 8 then
                setRotation(self.gearShifter, MathUtil.degToRad(10), MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.N, false);
	            setVisibility(self.FR, false);
	            setVisibility(self.T, false);
	            setVisibility(self.oneS, true);
	            setVisibility(self.twoS, false);
	            setVisibility(self.threeS, false);
	            setVisibility(self.fourS, false);
				
	            setVisibility(self.ND, false);
	            setVisibility(self.TD, false);
	            setVisibility(self.oneSD, true);
	            setVisibility(self.twoSD, false);
	            setVisibility(self.threeSD, false);
	            setVisibility(self.fourSD, false);
            elseif speed >= 8 and speed < 22 then
                setRotation(self.gearShifter, MathUtil.degToRad(20), MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.N, false);
	            setVisibility(self.FR, false);
	            setVisibility(self.T, false);
	            setVisibility(self.oneS, false);
	            setVisibility(self.twoS, true);
	            setVisibility(self.threeS, false);
	            setVisibility(self.fourS, false);
				
	            setVisibility(self.ND, false);
	            setVisibility(self.TD, false);
	            setVisibility(self.oneSD, false);
	            setVisibility(self.twoSD, true);
	            setVisibility(self.threeSD, false);
	            setVisibility(self.fourSD, false);
            elseif speed >= 22 and speed < 35 then
                setRotation(self.gearShifter, MathUtil.degToRad(30),  MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.N, false);
	            setVisibility(self.FR, false);
	            setVisibility(self.T, false);
	            setVisibility(self.oneS, false);
	            setVisibility(self.twoS, false);
	            setVisibility(self.threeS, true);
	            setVisibility(self.fourS, false);
				
	            setVisibility(self.ND, false);
	            setVisibility(self.TD, false);
	            setVisibility(self.oneSD, false);
	            setVisibility(self.twoSD, false);
	            setVisibility(self.threeSD, true);
	            setVisibility(self.fourSD, false);
            elseif speed >= 35 and speed < 45 then
                setRotation(self.gearShifter, MathUtil.degToRad(40),  MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.N, false);
	            setVisibility(self.FR, false);
	            setVisibility(self.T, false);
	            setVisibility(self.oneS, false);
	            setVisibility(self.twoS, false);
	            setVisibility(self.threeS, false);
	            setVisibility(self.fourS, true);
				
	            setVisibility(self.ND, false);
	            setVisibility(self.TD, false);
	            setVisibility(self.oneSD, false);
	            setVisibility(self.twoSD, false);
	            setVisibility(self.threeSD, false);
	            setVisibility(self.fourSD, true);
            end;
        end;
        if self.klawishaLH ~= nil then 
            if speed < 0.1 then
                setRotation(self.klawishaLH, MathUtil.degToRad(12),   MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.L, false);
	            setVisibility(self.H, false);
	            setVisibility(self.LD, false);
	            setVisibility(self.HD, false);
            elseif speed >= 0.1 and speed < 15 then
                setRotation(self.klawishaLH, MathUtil.degToRad(20), MathUtil.degToRad(0), MathUtil.degToRad(0));
	            setVisibility(self.L, true);
	            setVisibility(self.H, false);
	            setVisibility(self.LD, true);
	            setVisibility(self.HD, false);
            elseif speed >= 15 and speed < 45 then
	            setVisibility(self.L, false);
	            setVisibility(self.H, true);
	            setVisibility(self.LD, false);
	            setVisibility(self.HD, true);
                setRotation(self.klawishaLH, MathUtil.degToRad(6), MathUtil.degToRad(0), MathUtil.degToRad(0));
            end;
        end;  
	
	    if self.speedWaitingTimerMonitor < self.speedWaitingMaxTimeMonitor then 
	        setVisibility(self.monitorFirst, true); 
		    setVisibility(self.monitorSecond, false); 
		    setVisibility(self.monitorThird, false); 
	    end;
	    if self.speedWaitingTimerMonitor < (self.speedWaitingMaxTimeMonitor + self.speedWaitingMaxTimeMonitor) and self.speedWaitingTimerMonitor > self.speedWaitingMaxTimeMonitor then 
	        setVisibility(self.monitorFirst, false); 
		    setVisibility(self.monitorSecond, true); 
		    setVisibility(self.monitorThird, false); 
	    end;
	    if self.speedWaitingTimerMonitor < (self.speedWaitingMaxTimeMonitor + self.speedWaitingMaxTimeMonitor + self.speedWaitingMaxTimeMonitor) and self.speedWaitingTimerMonitor > (self.speedWaitingMaxTimeMonitor + self.speedWaitingTimerMonitor) then
    	    setVisibility(self.monitorFirst, false); 
		    setVisibility(self.monitorSecond, false); 
		    setVisibility(self.monitorThird, true); 
	    end;
	    self.speedWaitingTimerMonitor = self.speedWaitingTimerMonitor + dt;
	else 
	    self.speedWaitingTimerMonitor = 1; 
		setVisibility(self.monitorFirst, false); 
	    setVisibility(self.monitorSecond, false); 
	    setVisibility(self.monitorThird, false); 
	end;
	end;
end;

function K744R4:onUpdateTick(dt)
	local leverTrailers = self:getTrailer()
	local leverTurnedOn = self:getLoverTurnON()
    if leverTrailers ~= nil then
        if leverTrailers == Trailer.TIPSTATE_OPENING  then  
            self.leverTrailerMaxAktive = true
        elseif leverTrailers == Trailer.TIPSTATE_OPEN then 
            self.leverTrailerMaxAktive = false
        end
        if leverTrailers == Trailer.TIPSTATE_CLOSING  then 
            self.leverTrailerMinAktive = true
        elseif leverTrailers == Trailer.TIPSTATE_CLOSED then 
            self.leverTrailerMinAktive = false
        end
    end
    if leverTurnedOn ~= nil then
        if leverTurnedOn:getIsTurnedOn() then  
            self:playklawishaAnims(self.klawishaAnims.leverTurnON, 1);
        else
            self:playklawishaAnims(self.klawishaAnims.leverTurnON, -1);
		end;
	end;
	if self.leverTrailer ~= nil then
		local dir = 0;
		local hasRotChanged = false;
		local destRot = self.leverTrailer.minRot;
		
		if self.leverTrailerMinAktive then
			destRot = self.leverTrailer.upRot;
			dir = 1;
		end
		if self.leverTrailerMaxAktive then
			destRot = self.leverTrailer.downRot;
			dir = -1;
		end
		if self.leverTrailer.lastDir ~= dir then
			self.leverTrailer.lastDir = dir;
			self.leverTrailer.rotatingTime = 0;
		end
		
		if self.leverTrailer.rotatingTime ~= nil then
			self.leverTrailer.rotatingTime = self.leverTrailer.rotatingTime + dt;
			local t = math.min(1.0, self.leverTrailer.rotatingTime / self.leverTrailer.rotTime);
			if t == 1 then
				self.leverTrailer.rotatingTime = nil;
			end
			local rot = {getRotation(self.leverTrailer.node)};
			
			local rx1,ry1,rz1,rw1 = mathEulerToQuaternion(unpack(rot));
			local rx2,ry2,rz2,rw2 = mathEulerToQuaternion(unpack(destRot));
			
			local qx,qy,qz,qw = MathUtil.nlerpQuaternionShortestPath(rx1,ry1,rz1,rw1, rx2,ry2,rz2,rw2, t);
			setQuaternion(self.leverTrailer.node, qx,qy,qz,qw);
		end
	end;
    if self:getIsActive() then
        if self.spec_lights.turnLightState ~= nil then
			if self.blinkerhebel ~= nil then
				local dir = 0;
				local hasRotChanged = false;
				local destRot = self.blinkerhebel.minRot;
				
				if self.spec_lights.turnLightState == 1 then
					destRot = self.blinkerhebel.leftRot;
					dir = 1;
				elseif self.spec_lights.turnLightState == 2 then
					destRot = self.blinkerhebel.rightRot;
					dir = -1;
				end
				
				if self.blinkerhebel.lastDir ~= dir then
					self.blinkerhebel.lastDir = dir;
					self.blinkerhebel.rotatingTime = 0;
				end
				
				if self.blinkerhebel.rotatingTime ~= nil then
					self.blinkerhebel.rotatingTime = self.blinkerhebel.rotatingTime + dt;
					local t = math.min(1.0, self.blinkerhebel.rotatingTime / self.blinkerhebel.rotTime);
					if t == 1 then
						self.blinkerhebel.rotatingTime = nil;
					end
					local rot = {getRotation(self.blinkerhebel.node)};
					
					local rx1,ry1,rz1,rw1 = mathEulerToQuaternion(unpack(rot));
					local rx2,ry2,rz2,rw2 = mathEulerToQuaternion(unpack(destRot));
					
					local qx,qy,qz,qw = MathUtil.nlerpQuaternionShortestPath(rx1,ry1,rz1,rw1, rx2,ry2,rz2,rw2, t);
					setQuaternion(self.blinkerhebel.node, qx,qy,qz,qw);
				end
			end;
		end;
	end;
end;

function K744R4:playklawishaAnims(animName, animSpeed)    
    local animTime = self:getAnimationTime(animName);
    if not self:getIsAnimationPlaying(animName) then    
        self:playAnimation(animName, animSpeed, animTime, true);
    end;
end;

function K744R4:getTrailer()
	if self.getTipState ~= nil then
		return self:getTipState()
	else
        for _, implement in pairs(self.spec_attacherJoints.attachedImplements) do
            local trailer = implement.object
		    if trailer ~= nil and trailer.getTipState ~= nil  then
		    	return trailer:getTipState()
		    end
		end
	end
	return nil
end

function K744R4:getLoverTurnON()
	if self.getIsTurnedOn ~= nil then
		return self
	else
        for _, implement in pairs(self.spec_attacherJoints.attachedImplements) do
            local lover1 = implement.object
		    if lover1 ~= nil and lover1.getIsTurnedOn ~= nil  then
		    	return lover1
		    end
		end
	end
	return nil
end