--
-- Specialization K744R4Config
--
-- @author  	Aluha74rus
-- @version 	v1.0
-- @date  		20/03/20

K744R4Config = {};

function K744R4Config.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Wheels, specializations)
end;
-- function K744R4Config.registerFunctions(vehicleType)
    -- -- update
    -- SpecializationUtil.registerFunction(vehicleType, "finalizeWheel",   K744R4Config.finalizeWheel)
-- end

function K744R4Config.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", K744R4Config);
end

function K744R4Config.initSpecialization()
   g_configurationManager:addConfigurationType("windows", g_i18n:getText("configuration_windows"), nil, nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION)
   g_configurationManager:addConfigurationType("lightbar", g_i18n:getText("configuration_lightbar"), nil, nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION)
   g_configurationManager:addConfigurationType("tuning", g_i18n:getText("configuration_tuning"), nil, nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION)
   g_configurationManager:addConfigurationType("bortComp", g_i18n:getText("configuration_bortComp"), nil, nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION)
    g_configurationManager:addConfigurationType("rimColor1",   g_i18n:getText("configuration_rimColor1"), nil, nil, ConfigurationUtil.getConfigColorSingleItemLoad, ConfigurationUtil.getConfigColorPostLoad, ConfigurationUtil.SELECTOR_COLOR)
    g_configurationManager:addConfigurationType("rimColor2",   g_i18n:getText("configuration_rimColor2"), nil, nil, ConfigurationUtil.getConfigColorSingleItemLoad, ConfigurationUtil.getConfigColorPostLoad, ConfigurationUtil.SELECTOR_COLOR)
    g_configurationManager:addConfigurationType("rimColor3",   g_i18n:getText("configuration_rimColor3"), nil, nil, ConfigurationUtil.getConfigColorSingleItemLoad, ConfigurationUtil.getConfigColorPostLoad, ConfigurationUtil.SELECTOR_COLOR)
end

function K744R4Config:onLoad(savegame) 
	
    local configurations = Utils.getNoNil(self.configurations["bortComp"], 1, i)
    local configurations = Utils.getNoNil(self.configurations["lightbar"], 1, i)
    local configurations = Utils.getNoNil(self.configurations["tuning"], 1, i)
    local configurations = Utils.getNoNil(self.configurations["windows"], 1, i)
	
    local keyWindows = string.format("vehicle.windowsConfigurations.windowsConfiguration(%d)", self.configurations["windows"]-1)
    ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.windowsConfigurations.windowsConfiguration", self.configurations["windows"], self.components, self)
	
    local keyBortComp = string.format("vehicle.bortCompConfigurations.bortCompConfiguration(%d)", self.configurations["bortComp"]-1)
    ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.bortCompConfigurations.bortCompConfiguration", self.configurations["bortComp"], self.components, self)
	
	
    local key = string.format("vehicle.lightbarConfigurations.lightbarConfiguration(%d)", self.configurations["lightbar"]-1)
    ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.lightbarConfigurations.lightbarConfiguration", self.configurations["lightbar"], self.components, self)
    
	
    local key = string.format("vehicle.tuningConfigurations.tuningConfiguration(%d)", self.configurations["tuning"]-1)
    ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.tuningConfigurations.tuningConfiguration", self.configurations["tuning"], self.components, self)
	
    
    local rimColor1Str = getXMLString(self.xmlFile, "vehicle.wheels.rimColor1")
    if rimColor1Str ~= nil then
        self.rimColor1 = ConfigurationUtil.getColorFromString(rimColor1Str)
    elseif getXMLBool(self.xmlFile, "vehicle.wheels.rimColor1#useBaseColor") then
        self.rimColor1 = ConfigurationUtil.getColorByConfigId(self, "baseColor", self.configurations["baseColor"]) or ConfigurationUtil.getColorByConfigId(self, "baseMaterial", self.configurations["baseMaterial"])
    end
    if self.rimColor1 ~= nil then
        -- overwrite material from color string with nil unless explicitly defined in material attribute
        self.rimColor1[4] = getXMLInt(self.xmlFile, "vehicle.wheels.rimColor1#material")
    end
    
    local rimColor2Str = getXMLString(self.xmlFile, "vehicle.wheels.rimColor2")
    if rimColor2Str ~= nil then
        self.rimColor2 = ConfigurationUtil.getColorFromString(rimColor2Str)
    elseif getXMLBool(self.xmlFile, "vehicle.wheels.rimColor2#useBaseColor") then
        self.rimColor2 = ConfigurationUtil.getColorByConfigId(self, "baseColor", self.configurations["baseColor"]) or ConfigurationUtil.getColorByConfigId(self, "baseMaterial", self.configurations["baseMaterial"])
    end
    if self.rimColor2 ~= nil then
        -- overwrite material from color string with nil unless explicitly defined in material attribute
        self.rimColor2[4] = getXMLInt(self.xmlFile, "vehicle.wheels.rimColor2#material")
    end
    
    local rimColor3Str = getXMLString(self.xmlFile, "vehicle.wheels.rimColor3")
    if rimColor3Str ~= nil then
        self.rimColor3 = ConfigurationUtil.getColorFromString(rimColor3Str)
    elseif getXMLBool(self.xmlFile, "vehicle.wheels.rimColor3#useBaseColor") then
        self.rimColor3 = ConfigurationUtil.getColorByConfigId(self, "baseColor", self.configurations["baseColor"]) or ConfigurationUtil.getColorByConfigId(self, "baseMaterial", self.configurations["baseMaterial"])
    end
    if self.rimColor3 ~= nil then
        -- overwrite material from color string with nil unless explicitly defined in material attribute
        self.rimColor3[4] = getXMLInt(self.xmlFile, "vehicle.wheels.rimColor3#material")
    end
    
	
end;
function K744R4Config:finalizeWheel744(wheel, parentWheel)
    local configColor = ConfigurationUtil.getColorByConfigId(self, "rimColor1", self.configurations["rimColor1"])
    local color = wheel.color or configColor or self.rimColor1
    if color ~= nil then
        local r, g, b, mat = unpack(color)
        if wheel.wheelOuterRim ~= nil then
            -- never use material from config color since it is always '1'
            if mat == nil then
                _,_,_,mat = getShaderParameter(wheel.wheelOuterRim, "colorMat1")
            end
            setShaderParameter(wheel.wheelOuterRim, "colorMat1", r, g, b, mat, false)
        end
        if wheel.wheelInnerRim ~= nil then
            -- never use material from config color since it is always '1'
            if mat == nil then
                _,_,_,mat = getShaderParameter(wheel.wheelInnerRim, "colorMat1")
            end
            setShaderParameter(wheel.wheelInnerRim, "colorMat1", r, g, b, mat, false)
        end
    end
    local configColor = ConfigurationUtil.getColorByConfigId(self, "rimColor2", self.configurations["rimColor2"])
    local color = wheel.color or configColor or self.rimColor2
    if color ~= nil then
        local r, g, b, mat = unpack(color)
        if wheel.wheelOuterRim ~= nil then
            -- never use material from config color since it is always '1'
            if mat == nil then
                _,_,_,mat = getShaderParameter(wheel.wheelOuterRim, "colorMat2")
            end
            setShaderParameter(wheel.wheelOuterRim, "colorMat2", r, g, b, mat, false)
        end
        if wheel.wheelInnerRim ~= nil then
            -- never use material from config color since it is always '1'
            if mat == nil then
                _,_,_,mat = getShaderParameter(wheel.wheelInnerRim, "colorMat2")
            end
            setShaderParameter(wheel.wheelInnerRim, "colorMat2", r, g, b, mat, false)
        end
    end
    local configColor = ConfigurationUtil.getColorByConfigId(self, "rimColor3", self.configurations["rimColor3"])
    local color = wheel.color or configColor or self.rimColor3
    if color ~= nil then
        local r, g, b, mat = unpack(color)
        if wheel.wheelOuterRim ~= nil then
            -- never use material from config color since it is always '1'
            if mat == nil then
                _,_,_,mat = getShaderParameter(wheel.wheelOuterRim, "colorMat3")
            end
            setShaderParameter(wheel.wheelOuterRim, "colorMat3", r, g, b, mat, false)
        end
        if wheel.wheelInnerRim ~= nil then
            -- never use material from config color since it is always '1'
            if mat == nil then
                _,_,_,mat = getShaderParameter(wheel.wheelInnerRim, "colorMat3")
            end
            setShaderParameter(wheel.wheelInnerRim, "colorMat3", r, g, b, mat, false)
        end
    end
end

Wheels.finalizeWheel = Utils.appendedFunction(Wheels.finalizeWheel, K744R4Config.finalizeWheel744)